%global namedreltag -Final
%global namedversion %{version}%{?namedreltag}


%define with_ehcache 1
%define with_oscache 1
%define with_proxool 0
%define with_validator 0

Name:          hibernate3
Version:       3.5.6
Release:       %mkrel 2
Summary:       Relational persistence and query service
Group:         Development/Java
License:       LGPL
Url:           http://www.hibernate.org/
# svn export http://anonsvn.jboss.org/repos/hibernate/core/tags/hibernate-3.5.6-Final/
# tar czf hibernate-3.5.6-Final-src-svn.tar.gz hibernate-3.5.6-Final
Source0:       hibernate-3.5.6-Final-src-svn.tar.gz
# disable module(s)
#         + testsuite
#            - org.jboss.maven.plugins maven-test-ext-plugin 1.1.0
#         + cache-jbosscache 
#         + jdbc3-testing
#         + cache-infinispan
#         + documentation
#            - org.jboss.maven.plugins maven-jdocbook-plugin 2.2.3
#            - org.jboss.maven.plugins maven-jdocbook-style-plugin 2.0.0
#            - org.hibernate hibernate-jdocbook-style 2.0.1
#         + distribution
Patch0:        hibernate-3.5.6-Final-hibernate-pom-patch
# update gmaven groupId
# remove unavailable deps
Patch1:        hibernate-3.5.6-Final-parent-pom-patch
# used org.jboss.spec.* instead of org.jboss.javaee
# add objectweb-asm/asm 
# update ant groupId
Patch2:        hibernate-3.5.6-Final-core-pom-patch
# remove unavailable deps
Patch3:        hibernate-3.5.6-Final-annotations-pom-patch
# enable  module(s)
Patch4:        hibernate-3.5.6-Final-cache-ehcache.patch
Patch5:        hibernate-3.5.6-Final-cache-oscache.patch
Patch6:        hibernate-3.5.6-Final-entitymanager.patch

# https://hibernate.onjira.com/browse/HHH-5789
Patch7:        0004-strict-type-inference-with-generics-code.patch
Patch8:        hibernate-3.5.6-Final-envers.patch
# revert patch(es) 1,3,6
Patch9:        hibernate-3.5.6-Final-validator.patch

BuildRequires: ant
BuildRequires: antlr
BuildRequires: apache-commons-collections
BuildRequires: apache-commons-exec
BuildRequires: cglib
BuildRequires: dom4j
BuildRequires: h2
BuildRequires: hibernate-commons-annotations
BuildRequires: hibernate-jpa-2.0-api
BuildRequires: hibernate-jpamodelgen
BuildRequires: hibernate-validation-api
%if %with_validator
BuildRequires: hibernate-validator
%endif
BuildRequires: hibernate3-tools
BuildRequires: hsqldb
BuildRequires: javassist
BuildRequires: jboss-common-core
BuildRequires: jboss-jacc-1.4-api
BuildRequires: jboss-logging-spi
BuildRequires: jboss-servlet-3.0-api
BuildRequires: jboss-transaction-1.1-api
BuildRequires: junit
BuildRequires: antlr-maven-plugin
BuildRequires: findbugs-maven-plugin
BuildRequires: gmaven
BuildRequires: maven
BuildRequires: maven-antrun-plugin
BuildRequires: maven-compiler-plugin
BuildRequires: maven-injection-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-enforcer-plugin
BuildRequires: maven-release-plugin
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: mysql-connector-java
BuildRequires: ehcache-parent
BuildRequires: c3p0
#  TODO
# hibernate-jbosscache org.jboss.cache jbosscache-core 3.2.1.G
# hibernate-infinispan org.infinispan infinispan-core 4.2.0.ALPHA1 

%if %with_ehcache
BuildRequires: ehcache-core
%endif
%if %with_oscache
BuildRequires: oscache
%endif
%if %with_proxool
BuildRequires: proxool
%endif
BuildRequires: slf4j
BuildRequires: swarmcache
BuildRequires: testng

Requires:      antlr
Requires:      apache-commons-collections
Requires:      cglib
Requires:      dom4j
Requires:      javassist
Requires:      jboss-common-core
Requires:      jboss-jacc-1.4-api
Requires:      jboss-logging-spi
Requires:      jboss-servlet-3.0-api
Requires:      jboss-transaction-1.1-api
Requires:      objectweb-asm
%if %with_proxool
BuildRequires: proxool
%endif

Requires:      java
Requires:      jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
BuildArch:     noarch

%description
Hibernate is a powerful, ultra-high performance
object/relational persistence and query service
for Java. Hibernate lets you develop persistent
objects following common Java idiom - including
association, inheritance, polymorphism, composition
and the Java collections framework. Extremely
fine-grained, richly typed object models are
possible. The Hibernate Query Language, designed
as a "minimal" object-oriented extension to SQL,
provides an elegant bridge between the object and
relational worlds. Hibernate is now the most
popular ORM solution for Java.

%package javadoc
Summary:       Javadocs for %{name}
Group:         Development/Java
Requires:      jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n hibernate-%{namedversion}

%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0
%if %with_ehcache
%patch4 -p0
%endif
%if %with_oscache
%patch5 -p0
%endif
%patch6 -p1
%patch7 -p1
%patch8 -p1

%if %with_validator
%patch9 -p1
%endif

%if %with_proxool
sed -i "s|<!--module>connection-proxool</module-->|<module>connection-proxool</module>|" pom.xml
%endif
#sed -i "s|<!--module>jdbc3-testing</module-->|<module>jdbc3-testing</module>|" pom.xml

%build

mvn-rpmbuild  \
  -e \
  -Dmaven.test.skip=true \
  -Djdk16_home=%{_jvmdir}/java \
  install javadoc:aggregate

%install
[ %{buildroot} != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}%{_javadir}

install -pm 644 core/target/hibernate-core-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-core-%{version}.jar

install -pm 644 annotations/target/hibernate-annotations-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-annotations-%{version}.jar

install -pm 644 connection-c3p0/target/hibernate-c3p0-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-c3p0-%{version}.jar

install -pm 644 jmx/target/hibernate-jmx-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-jmx-%{version}.jar

install -pm 644 cache-swarmcache/target/hibernate-swarmcache-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-swarmcache-%{version}.jar

%if %with_ehcache
install -pm 644 cache-ehcache/target/hibernate-ehcache-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-ehcache-%{version}.jar
%endif
%if %with_oscache
install -pm 644 cache-oscache/target/hibernate-oscache-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-oscache-%{version}.jar
%endif
%if %with_proxool
install -pm 644 connection-proxool/target/hibernate-proxool-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-proxool-%{version}.jar
%endif

install -pm 644 entitymanager/target/hibernate-entitymanager-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-entitymanager-%{version}.jar

#install -pm 644 jdbc3-testing/target/hibernate-jdbc3-testing-%{namedversion}.jar \
#  %{buildroot}%{_javadir}/%{name}-jdbc3-testing-%{version}.jar

install -pm 644 jdbc4-testing/target/hibernate-jdbc4-testing-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-jdbc4-testing-%{version}.jar

install -pm 644 envers/target/hibernate-envers-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-envers-%{version}.jar

install -pm 644 testing/target/hibernate-testing-%{namedversion}.jar \
  %{buildroot}%{_javadir}/%{name}-testing-%{version}.jar

(
  cd %{buildroot}%{_javadir}
  for jar in *-%{version}*; do
    ln -sf ${jar} ${jar/-%{version}/}
  done
)

mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 parent/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-parent.pom
%add_maven_depmap JPP-%{name}-parent.pom
install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%add_maven_depmap JPP-%{name}.pom
install -pm 644 core/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-core.pom
%add_maven_depmap JPP-%{name}-core.pom %{name}-core.jar
install -pm 644 annotations/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-annotations.pom
%add_maven_depmap JPP-%{name}-annotations.pom %{name}-annotations.jar
install -pm 644 connection-c3p0/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-c3p0.pom
%add_maven_depmap JPP-%{name}-c3p0.pom %{name}-c3p0.jar
install -pm 644 jmx/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-jmx.pom
%add_maven_depmap JPP-%{name}-jmx.pom %{name}-jmx.jar
%if %with_ehcache
install -pm 644 cache-ehcache/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-ehcache.pom
%add_maven_depmap JPP-%{name}-ehcache.pom %{name}-ehcache.jar
%endif
%if %with_oscache
install -pm 644 cache-oscache/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-oscache.pom
%add_maven_depmap JPP-%{name}-oscache.pom %{name}-oscache.jar
%endif
%if %with_proxool
install -pm 644 connection-proxool/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-proxool.pom
%add_maven_depmap JPP-%{name}-proxool.pom %{name}-proxool.jar
%endif
install -pm 644 cache-swarmcache/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-swarmcache.pom
%add_maven_depmap JPP-%{name}-swarmcache.pom %{name}-swarmcache.jar

install -pm 644 entitymanager/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-entitymanager.pom
%add_maven_depmap JPP-%{name}-entitymanager.pom %{name}-entitymanager.jar

#install -pm 644 jdbc3-testing/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-jdbc3-testing.pom
#dd_maven_depmap JPP-%{name}-jdbc3-testing.pom %{name}-jdbc3-testing.jar

install -pm 644 jdbc4-testing/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-jdbc4-testing.pom
%add_maven_depmap JPP-%{name}-jdbc4-testing.pom %{name}-jdbc4-testing.jar

install -pm 644 envers/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-envers.pom
%add_maven_depmap JPP-%{name}-envers.pom %{name}-envers.jar

install -pm 644 testing/pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}-testing.pom
%add_maven_depmap JPP-%{name}-testing.pom %{name}-testing.jar

mkdir -p %{buildroot}%{_datadir}/%{name}-%{version}/etc
cp -pr etc/* %{buildroot}%{_datadir}/%{name}-%{version}/etc

mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}


%post
%update_maven_depmap

%preun
%update_maven_depmap

%files
%{_javadir}/%{name}-core-%{version}.jar
%{_javadir}/%{name}-core.jar
%{_javadir}/%{name}-annotations-%{version}.jar
%{_javadir}/%{name}-annotations.jar
%{_javadir}/%{name}-c3p0-%{version}.jar
%{_javadir}/%{name}-c3p0.jar
%if %with_ehcache
%{_javadir}/%{name}-ehcache-%{version}.jar
%{_javadir}/%{name}-ehcache.jar
%endif
%{_javadir}/%{name}-entitymanager-%{version}.jar
%{_javadir}/%{name}-entitymanager.jar
%{_javadir}/%{name}-envers-%{version}.jar
%{_javadir}/%{name}-envers.jar
%{_javadir}/%{name}-jdbc4-testing-%{version}.jar
%{_javadir}/%{name}-jdbc4-testing.jar
%{_javadir}/%{name}-jmx-%{version}.jar
%{_javadir}/%{name}-jmx.jar
%if %with_oscache
%{_javadir}/%{name}-oscache-%{version}.jar
%{_javadir}/%{name}-oscache.jar
%endif
%if %with_proxool
%{_javadir}/%{name}-proxool-%{version}.jar
%{_javadir}/%{name}-proxool.jar
%endif
%{_javadir}/%{name}-swarmcache-%{version}.jar
%{_javadir}/%{name}-swarmcache.jar
%{_javadir}/%{name}-testing-%{version}.jar
%{_javadir}/%{name}-testing.jar
%{_datadir}/%{name}-%{version}/*
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/*
%doc changelog.txt hibernate_logo.gif lgpl.txt


%files javadoc
%{_javadocdir}/%{name}


%changelog

* Sun Nov 27 2011 dmorgan <dmorgan> 3.5.6-2.mga2
+ Revision: 172488
- Disable proxool support
- Disable validator support

  + gil <gil>
    - rebuilt enable ehcache oscache proxool modules

* Thu Oct 27 2011 dmorgan <dmorgan> 3.5.6-1.mga2
+ Revision: 158608
- Adapt to mageia guidelines

  + gil <gil>
    - imported package hibernate3

